#if !defined(FO_EXTACTORSHAPE_H__1E437020_F0A3_41D3_898C_C4BD52EBE8EE__INCLUDED_)
#define FO_EXTACTORSHAPE_H__1E437020_F0A3_41D3_898C_C4BD52EBE8EE__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000


//------------------------------------------------------
// Description
// Author: Author Name.
//------------------------------------------------------
#define EXT_ACTOR_SHAPE	FO_COMP_CUSTOM + 2

class CExtActorShape : public CFODrawPortsShape  
{
protected:
	DECLARE_SERIAL(CExtActorShape);
public:

	// constructor
	CExtActorShape();

	// Copy constructor.
	CExtActorShape(const CExtActorShape& src);

	// Destructor.
	virtual ~CExtActorShape();

	// Creates the button Shape from a CRect object.
	virtual void Create(CRect &rcPos,CString strCaption = "");

public:

	// Assignment operator.
	CExtActorShape& operator=(const CExtActorShape& src);

	// Creates a copy of this Shape.
	virtual CFODrawShape* Copy() const;

	// Update shape's area.
	virtual void GeometryUpdated(CFOArea* pRgn);

	// Obtain the composite of the shape.
	virtual void GetPathSimplePolygon(FOPSimpleCompositePolygon& rPoly) const;

	// Calc text line array.
	virtual int CreateTextArray(CDC* pDC, CString strText,CRect rcBox,CStringArray& arLines);

	// Get text box size.
	virtual CSize GetTextSize(CDC* pDC,CRect rcPos,CString strText);

	// Get format type.
	UINT GetDrawFormatType();

public:

	// Serializes the data.
	virtual void Serialize(CArchive &ar);
	
	// Save document.
	virtual BOOL SaveDocument(LPCTSTR lpszPathName);

	// Open document.
	virtual BOOL OpenDocument(LPCTSTR lpszPathName);
	
	// Get file.
	CFile *GetFile(LPCTSTR lpszFileName, UINT nOpenFlags,CFileException* pError);
	
	// Release file.
	virtual void ReleaseFile(CFile* pFile, BOOL bAbort);

public:

	//Draw flat status.
	// Draws custom tracker.
	virtual void OnDrawTrackCustom(CDC *pDC);

	// Do draw visio like bounding selection line.
	// pDC -- pointer of the DC.
	virtual void DoDrawVisioOrderLine(CDC *pDC);

	// Creates GDI objects and sets up the device context for drawing. 
	virtual void PrepareDC(CDC* pDC);

	// Draws the truely shape.
	virtual void OnDraw(CDC *pDC);

	// Draws the flat status of the Shape.
	virtual void OnDrawFlat(CDC *pDC);

	// Draws shadow of Shape.
	virtual void OnDrawShadow(CDC *pDC);

	// Draws the 3D status of the Shape.
	virtual void OnDraw3d(CDC *pDC);

	// Frees GDI objects and restores the state of the device context.
	virtual void ClearDC(CDC* pDC);
	// Implementation

public:

#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

};



#endif // !defined(FO_EXTACTORSHAPE_H__1E437020_F0A3_41D3_898C_C4BD52EBE8EE__INCLUDED_)
